#! perl
# CP932toUTF-16LE.pl -- UTF-8ファイルをUTF-16LEに変換（難アリ）
# （UTF-8で保存して実行すること）

use strict;
use warnings;

use utf8;

open IN,    '<:encoding(cp932)', 'C:\foo\input.txt';
open OUT,    '>:encoding(UTF-16LE)', 'C:\foo\output.txt';

print OUT "\x{FEFF}"; # BOMを出力

while(<IN>) {
    print OUT;           # 入力をそのまま出力するだけ
}

close IN;
close OUT;

