# jisX0212_table_make.pl -- unicode.org̃R[h\Ɏۂ̎`Ƌ_𖄂ߍ

$in = 'C:\Perl\JIS0212.TXT';                    # ̓t@CŒŃn[hR[h
$out = 'C:\Perl\my_jisx0212_unicode_table.txt'; # o̓t@CŒŃn[hR[h

open IN, $in or die "$!";                       # ̓t@CI[v
open OUT, '>'.$out or die "$!";                 # o̓t@CI[v
binmode IN;                                     # ̓t@CoCi[[hœǂ
binmode OUT;                                    # o̓t@CoCi[[hœǂ
select OUT;                                     # print֐̃ftHgo͐OUTɐ؂ւ

print "\xfe\xff";                               # UTF-16(BE)BOMo

# Ao
print &asc2uni('

This charcode table is converted from JIS0212.TXT

oririnal format:
    jis_x_0212 utf-16-be                        # unicode name
    target format shown as below;
    ku-ten jis_x_0212 utf-16-be actual_glyph    # unicode name
----
');

$sp = &asc2uni("\t");                           # ^uUnicode
$hyphen = &asc2uni('-');                        # nCt-}CiXUnicode

while (<IN>) {                                  # $in̊es$_ɓȂ烋[v
    next if /^\#/;                              # 擪#Ȃǂݔ΂
    ($gl, $uni, $mojimei) = split /\t/;         # s^uŕJIS GLR[hAUCS-2lA

    # GLR[h0xHHLĽ`ɂȂĂBHHʃjuALLʃjuƌĂ
    $ku = &asc2uni(unpack("c", (pack "H2", (substr $gl, 2, 2))) - 32);  # GLR[h̏ʃjuԍɊZ
    $ten = &asc2uni(unpack("c", (pack "H2", (substr $gl, 4, 2))) - 32); # GLR[h̉ʃju_ԍɊZ

    $uni_packed = pack "H4", (substr $uni, 2);  # UCS-2l̉4pbN

    # GLlAUCS-2lAUnicode
    $gl = &asc2uni($gl);
    $uni = &asc2uni($uni);
    $mojimei = &asc2uni($mojimei);
    print $ku, $hyphen, $ten, $sp, $gl, $sp, $uni, $sp, $uni_packed, $sp, $mojimei; # Ԃɕ\
}

# t@C
close IN;
close OUT;

sub asc2uni {                     # ASCIIUnicodeɂTu[`
    my $asc = shift;              # ɃAXL[l𓾂
    my $uni = '';                 # UnicodeAĂGA󕶎ŏ
    my @asc = split //, $asc;     # ASCIIl1Ĕzɓ
    for my $asc_char (@asc) {     # ̔z1$asc_charɓȂ烋[v
        $uni .= "\x00".$asc_char; # ASCIIl̑O0x00ꂽ́iUnicodeɁj$uniɂȂ
    }
    return $uni;                  # $uniԂ
}

