#! perl
# newUniFile.pl -- Unicode文字をファイルから入力する（binmode版）
# （UTF-8で保存して実行すること）

use strict;
use warnings;

use utf8;

open IN,  '<', 'C:\foo\input.txt';
open OUT, '>', 'C:\foo\output.txt';

binmode IN,  ':encoding(cp932)';
binmode OUT, ':encoding(cp932)';

my $text = <IN>;

my @arr = split //, $text; # 配列@arrに1文字ずつ格納する

my $i = 0;

for my $char (@arr) {
    print OUT ++$i, ':', $char, "\n";
}

close IN;
close OUT;

