#! perl
# u8search.pl -- UTF-8ファイルを検索する
# （UTF-8で保存して実行すること）

use strict;
use warnings;

use utf8;

open IN,  '<:encoding(UTF-8)', 'C:\foo\input.txt';
open OUT, '>:encoding(cp932)', 'C:\foo\output.txt';

while(<IN>) {
    print OUT if /[ぁ-ん]/; # ひらがなが存在したら出力する
}

close IN;
close OUT;

