#! perl
# utf16_to_cp932.pl -- UTF-16LEファイルをcp932に変換（修正）
# （UTF-8で保存して実行すること）

use strict;
use warnings;

use utf8;

open IN, '<:raw:encoding(UTF-16LE):crlf', 'C:\foo\input.txt';
open OUT,   '>:encoding(cp932)', 'C:\foo\output.txt';

while(<IN>) {
    print OUT;  # 入力をそのまま出力するだけ
}

close IN;
close OUT;

