#! perl
# UTF-8toCP932.pl -- UTF-8ファイルをCP932に変換
# （UTF-8で保存して実行すること）

use strict;
use warnings;

use utf8;

open IN,  '<:encoding(UTF-8)', 'C:\foo\input.txt';
open OUT, '>:encoding(cp932)', 'C:\foo\output.txt';

while(<IN>) {
    print OUT;  # 入力をそのまま出力するだけ
}

close IN;
close OUT;

