#! perl
# newUniFile.pl -- Unicode文字をファイルから入力する（encode/decode版）
# （UTF-8で保存して実行すること）

use strict;
use warnings;

use Encode;

use utf8;

open IN,  '<', 'C:\foo\input.txt';
open OUT, '>', 'C:\foo\output.txt';

my $text = decode('cp932', <IN>);

my @arr = split //, $text; # 配列@arrに1文字ずつ格納する

my $i = 0;

for my $char (@arr) {
    print OUT ++$i, ':', encode('cp932', $char), "\n";
}

close IN;
close OUT;

