#! perl
# newUniFile.pl -- Unicode文字をファイルから入力する（open版）
# （UTF-8で保存して実行すること）

use strict;
use warnings;

use utf8;

open IN,  '<:encoding(cp932)', 'C:\foo\input.txt';
open OUT, '>:encoding(cp932)', 'C:\foo\output.txt';

my $text = <IN>;

my @arr = split //, $text; # 配列@arrに1文字ずつ格納する

my $i = 0;

for my $char (@arr) {
    print OUT ++$i, ':', $char, "\n";
}

close IN;
close OUT;
