# sjis_analyse.pl -- Shift_JIS分別

use utf8;

$in = shift;

binmode STDOUT,":encoding(cp932)";

open IN, "<:encoding(cp932)", $in;

while (<IN>) {
    print "$.行-かな: $_" if /[ぁ-ん]/;     # 全角ひらがな、ぁからんまで
    print "$.行-カナ: $_" if /[ァ-ン]/;     # 全角カタカナ、ァからンまで
    print "$.行-英字: $_" if /[a-zA-Z]/;    # ASCII、aからzまで、および、AからZまで
    print "$.行-数字: $_" if /[0-9]/;       # ASCII、0から9まで
    print "$.行-ﾊﾝｶﾅ: $_" if /[ｦ-ﾟ]/;       # 半角カナ、ヲから半濁点まで
}

close IN;

