# ucs4_to_utf8.pl -- UCS-4lUTF-8ɕϊ

$ucs4_hex = shift;

$ucs4_dec = hex $ucs4_hex;              # 16i𐔒lɕϊ
$ucs4_packed = pack "N", $ucs4_dec;     # 32rbg̃oCi[ɃpbN
$ucs4_str = unpack "B32", $ucs4_packed; # 32rbg2iɃApbN

if ($ucs4_dec < 0x00000080) {           # 0x00000080̏ꍇ
    $byte = substr $ucs4_str, -8;       # 8rbg擾
    $hex = &byte2hex($byte);            # 16iɕϊ
    print "$hex\n";                     # \

} elsif ($ucs4_dec < 0x00000800) {      # i0x00000080ȏŁj0x00000800̏ꍇ
    $byte = '10'.substr $ucs4_str, -6;  # 6rbg擾'10'擪ɕt
    $hex1 = &byte2hex($byte);           # 16iɕϊ
    $byte = '110'.substr $ucs4_str, -11, 5; # 11rbgڂ5rbg擾'110'擪ɕt
    $hex2 = &byte2hex($byte);           # 16iɕϊ
    print "$hex2 $hex1\n";              # \

} elsif ($ucs4_dec < 0x00010000) {      # i0x00000800ȏŁj0x00010000̏ꍇ
    $byte = '10'.substr $ucs4_str, -6;  # 6rbg擾'10'擪ɕt
    $hex1 = &byte2hex($byte);           # 16iɕϊ
    $byte = '10'.substr $ucs4_str, -12, 6; # 12rbgڂ6rbg擾'10'擪ɕt
    $hex2 = &byte2hex($byte);           # 16iɕϊ
    $byte = '1110'.substr $ucs4_str, -16, 4; # 16rbgڂ4rbg擾'1110'擪ɕt
    $hex3 = &byte2hex($byte);           # 16iɕϊ
    print "$hex3 $hex2 $hex1\n";        # \

} elsif ($ucs4_dec < 0x00200000) {      # i0x00010000ȏŁj0x00200000̏ꍇ
    $byte = '10'.substr $ucs4_str, -6;  # 6rbg擾'10'擪ɕt
    $hex1 = &byte2hex($byte);           # 16iɕϊ
    $byte = '10'.substr $ucs4_str, -12, 6; # 12rbgڂ6rbg擾'10'擪ɕt
    $hex2 = &byte2hex($byte);           # 16iɕϊ
    $byte = '10'.substr $ucs4_str, -18, 6; # 18rbgڂ6rbg擾'10'擪ɕt
    $hex3 = &byte2hex($byte);           # 16iɕϊ
    $byte = '11110'.substr $ucs4_str, -21, 3; # 21rbgڂ3rbg擾'11110'擪ɕt
    $hex4 = &byte2hex($byte);           # 16iɕϊ
    print "$hex4 $hex3 $hex2 $hex1\n";  # \
} elsif ($ucs4_dec < 0x04000000) {      # i0x00200000ȏŁj0x04000000̏ꍇ
    $byte = '10'.substr $ucs4_str, -6;  # 6rbg擾'10'擪ɕt
    $hex1 = &byte2hex($byte);           # 16iɕϊ
    $byte = '10'.substr $ucs4_str, -12, 6; # 12rbgڂ6rbg擾'10'擪ɕt
    $hex2 = &byte2hex($byte);           # 16iɕϊ
    $byte = '10'.substr $ucs4_str, -18, 6; # 18rbgڂ6rbg擾'10'擪ɕt
    $hex3 = &byte2hex($byte);           # 16iɕϊ
    $byte = '10'.substr $ucs4_str, -24, 6; # 24rbgڂ6rbg擾'10'擪ɕt
    $hex4 = &byte2hex($byte);           # 16iɕϊ
    $byte = '111110'.substr $ucs4_str, -26, 2; # 26rbgڂ3rbg擾'111110'擪ɕt
    $hex5 = &byte2hex($byte);           # 16iɕϊ
    print "$hex5 $hex4 $hex3 $hex2 $hex1\n"; # \
} else { # 0x04000000ȏ̏ꍇ
    $byte = '10'.substr $ucs4_str, -6;  # 6rbg擾'10'擪ɕt
    $hex1 = &byte2hex($byte); # 16iɕϊ
    $byte = '10'.substr $ucs4_str, -12, 6; # 12rbgڂ6rbg擾'10'擪ɕt
    $hex2 = &byte2hex($byte);           # 16iɕϊ
    $byte = '10'.substr $ucs4_str, -18, 6; # 18rbgڂ6rbg擾'10'擪ɕt
    $hex3 = &byte2hex($byte);           # 16iɕϊ
    $byte = '10'.substr $ucs4_str, -24, 6; # 24rbgڂ6rbg擾'10'擪ɕt
    $hex4 = &byte2hex($byte);           # 16iɕϊ
    $byte = '10'.substr $ucs4_str, -30, 6; # 30rbgڂ6rbg擾'10'擪ɕt
    $hex5 = &byte2hex($byte);           # 16iɕϊ
    $byte = '1111110'.substr $ucs4_str, -31, 1; # 31rbgڂ1rbg擾'111110'擪ɕt
    $hex6 = &byte2hex($byte);           # 16iɕϊ
    print "$hex6 $hex5 $hex3 $hex2 $hex1\n"; # \
}

sub byte2hex { # 2i816iɕϊĕԂ
    my $byte = shift;
    my $str = ('0'x(32 - length $byte)).$byte; # 0t32rbg
    my $packed = pack "B32", $str;             # 32rbg̃oCi[ɃpbN
    my $dec = unpack "N", $packed;             # 10ilɕϊ
    my $hex = sprintf '%x', $dec;              # 16iɕϊ
    return $hex; # ϊʂԂ
}

